/*
 * $Id: gd32v_hw_adc.h 498 2021-07-23 19:38:20Z true $
 * begin 20210621 true
 */

#ifndef INC_DRIVER_GD32V_HW_ADC_H_
#define INC_DRIVER_GD32V_HW_ADC_H_



#include <stdint.h>
#include "gd32vf103.h"



#define ADC_CHAN_COUNT          4

#define ADC_CHAN_LIGHTSENS      0
#define ADC_CHAN_BATTERY        1
#define ADC_CHAN_TEMPERATURE    2
#define ADC_CHAN_VREF           3



void gd32v_adc_init();
void gd32v_adc_tick();

void gd32v_adc_dma_complete_cb();

uint16_t adc_get_temp_degc_x10();
uint16_t adc_get_val_raw(uint8_t chan);
uint16_t adc_get_val_avg(uint8_t chan);



#endif /* INC_DRIVER_GD32V_HW_ADC_H_ */