/*
 * $Id: gd32v_hw_hwid.h 494 2021-07-21 11:46:11Z true $
 * begin 20190527 true
 */


#ifndef INC_DRIVER_HWID_H_
#define INC_DRIVER_HWID_H_



#include "gd32vf103.h"



#define HWID_MODEL_F32G		        0x00
#define HWID_MODEL_F64G		        0x01
#define HWID_MODEL_GD32VF103_64K    0x80
#define HWID_MODEL_GD32VF103_128K   0x81
#define HWID_MODEL_UNKNOWN          0xff

#define HWID_LENGTH_UNIQUEID        12
#define HWID_ADDR_MEMDENSITY        (uint32_t *)0x1ffff7e0
#define HWID_ADDR_UNIQUEID          (uint32_t *)0x1ffff7e8



void    hwid_init();
uint8_t hwid_get_model();
uint8_t hwid_get_byte(uint8_t byte);

uint16_t hwid_get_sram_size();
uint16_t hwid_get_flash_size();



extern uint8_t *hwid;		// direct access if you know what you are doing



#endif /* INC_DRIVER_HWID_H_ */
