/*
 * $Id: gd32v_hw_i2c.h 500 2021-08-08 19:43:38Z true $
 * begin 20210618 true
 */

#ifndef INC_DRIVER_GD32V_HW_I2C_H_
#define INC_DRIVER_GD32V_HW_I2C_H_



#include <stdint.h>
#include "gd32vf103.h"


#define GD32V_I2C_IDLE      0x00
#define GD32V_I2C_TX_SETUP  0x01
#define GD32V_I2C_TX_ADDR   0x02
#define GD32V_I2C_TX        0x03
#define GD32V_I2C_TX_ERR    0x0f
#define GD32V_I2C_RX_SETUP  0x11
#define GD32V_I2C_RX_ADDR   0x12
#define GD32V_I2C_RX        0x13

#define GD32V_I2C_DMA_DONE  0x8e

#define I2C0_DATA_ADDRESS   0x40005410
#define I2C1_DATA_ADDRESS   0x40005810



extern volatile uint8_t i2c_reset;
extern volatile uint8_t i2c_last_err_reason[2];
extern volatile uint8_t i2c_state[2];


extern uint32_t i2c_err_cnt[2];



void i2c_init();

void i2c_bus_reset(uint32_t gpio, uint16_t sda, uint16_t scl);

void i2c_write(uint8_t i2c, uint8_t slave, const uint8_t *buf, uint16_t bytes, void(*completed_callback)(uint8_t));

void i2c_ev_isr(uint8_t i2c);
void i2c_err_isr(uint8_t i2c);
void i2c_dma_complete_cb(uint8_t i2c);


#endif /* INC_DRIVER_GD32V_HW_I2C_H_ */
