/*
 * $Id: shiftreg.h 494 2021-07-21 11:46:11Z true $
 * begin 20210621 true
 */

#ifndef INC_DRIVER_SHIFTREG_H_
#define INC_DRIVER_SHIFTREG_H_


#include <stdint.h>



// hardware
#define SIPO_SPI_DEV            SPI0

#define SIPO_LAT_PORT           GPIOB
#define SIPO_LAT_PIN            GPIO_PIN_2
#define SIPO_OE_PORT            GPIOC
#define SIPO_OE_PIN             GPIO_PIN_13

#define SIPO_COUNT              1       // how many shift registers?

// implementation specific
#define SIPO0_EDGE_BITS         0xf8
#define SIPO0_EDGE_SHIFT        3
#define SIPO0_EYES_BITS         0x06
#define SIPO0_EYES_SHIFT        1
#define SIPO0_AUXPWR_BITS       0x01
#define SIPO0_AUXPWR_SHIFT      0



extern uint8_t sipo_data[SIPO_COUNT];



void shiftreg_update();
void shiftreg_oe(uint8_t enable);

void shiftreg0_auxpwr(uint8_t enable);
void shiftreg0_edge(uint8_t edgebits);
void shiftreg0_eyes(uint8_t eyesbits);



#endif
