/*
 * $Id: rgbled.h 499 2021-07-26 05:24:02Z true $
 * begin 20190525 true
 */

#ifndef INC_LED_RGBLED_H_
#define INC_LED_RGBLED_H_



#include "disp/color_hsv.h"


// two eye LEDs
#define RGBLED_EYE_PWM_PORT     GPIOA
#define RGBLED_EYE_PWM_PIN_RED  GPIO_PIN_8
#define RGBLED_EYE_PWM_PIN_GRN  GPIO_PIN_9
#define RGBLED_EYE_PWM_PIN_BLU  GPIO_PIN_10
#define RGBLED_EYE_SEL_LEFT     0x01
#define RGBLED_EYE_SEL_RIGHT    0x02

// ten surrounding LEDs
#define RGBLED_EDGE_PWM_PORT    GPIOB
#define RGBLED_EDGE_PWM_PIN1    GPIO_PIN_0
#define RGBLED_EDGE_PWM_PIN2    GPIO_PIN_1
#define RGBLED_EDGE_PWM_PIN3    GPIO_PIN_4
#define RGBLED_EDGE_PWM_PIN4    GPIO_PIN_5
#define RGBLED_EDGE_PWM_PIN5    GPIO_PIN_8
#define RGBLED_EDGE_PWM_PIN6    GPIO_PIN_9

#define RGB_EDGE_COUNT			10
#define RGB_EYES_COUNT			2
#define RGBLED_COUNT            (2+10)

typedef struct LedProgram {
	char *name;
	void (*prog)(uint8_t *, uint16_t);
} LedProgram;



extern const uint8_t edge_map[10];

extern       color_hsv  hsv_edge[RGB_EDGE_COUNT];
extern       color_hsv  hsv_eyes[RGB_EYES_COUNT];

extern const LedProgram edge_pgm[6];
extern const LedProgram eyes_pgm[6];

extern uint16_t eyes_val_lsens;



void rgb_eyes_update(uint8_t idx);
void rgb_edge_update(uint8_t idx);



#endif // INC_LED_RGBLED_H
