/*
 * $Id: gd32v_hw_hwid.c 497 2021-07-23 03:42:57Z true $
 * begin 20210619 true
 * 
 * misc hwid shit
 */


#include "driver/gd32v_hw_hwid.h"


uint8_t *hwid;


void hwid_init()
{
    hwid = (uint8_t *)HWID_ADDR_UNIQUEID;
}

uint16_t hwid_get_sram_size()
{
    uint32_t *memd = HWID_ADDR_MEMDENSITY;
    return (*memd >> 16);
}

uint16_t hwid_get_flash_size()
{
    uint32_t *memd = HWID_ADDR_MEMDENSITY;
    return (*memd & 0xffff);
}

uint8_t hwid_get_model()
{
    if (hwid_get_flash_size() == 64) {
        return HWID_MODEL_GD32VF103_64K;
    }
    if (hwid_get_flash_size() == 128) {
        return HWID_MODEL_GD32VF103_128K;
    }
	
    return HWID_MODEL_UNKNOWN;
}

uint8_t hwid_get_byte(uint8_t byte)
{
	if (byte < HWID_LENGTH_UNIQUEID) {
		return hwid[byte];
	}
	return 0;
}
