/*
 * GD32V Interrupts
 */

#include "gd32vf103.h"
#include "fw_app.h"

#include "driver/gd32v_hw_adc.h"
#include "driver/gd32v_hw_i2c.h"
#include "ui/btn.h"



void EXTI0_IRQHandler(void)
{
    exti_interrupt_flag_clear(EXTI_0);
}

void TIMER5_IRQHandler(void)
{
    if (timer_interrupt_flag_get(TIMER5, TIMER_INT_UP)) {
        timer_interrupt_flag_clear(TIMER5, TIMER_INT_UP);

        fw_status |= FW_STATUS_INTERRUPT;
        fw_tick_critical();    
    }    
}

void I2C0_EV_IRQHandler(void)
{
    i2c_ev_isr(0);
}

void I2C0_ERR_IRQHandler(void)
{
    i2c_err_isr(0);
}

void USART1_IRQHandler(void)
{
    if (usart_interrupt_flag_get(USART1, USART_INT_FLAG_RBNE)) {
        usart_interrupt_flag_clear(BTN_USART, USART_INT_FLAG_RBNE);
        btn_data_isr(0);
    }
    if (usart_interrupt_flag_get(USART1, USART_INT_FLAG_IDLE)) {
        btn_data_isr(1);
    }
}

// adc
void DMA0_Channel0_IRQHandler(void)
{
    if (dma_interrupt_flag_get(DMA0, DMA_CH0, DMA_INT_FLAG_FTF)) {     
        dma_interrupt_flag_clear(DMA0, DMA_CH0, DMA_INT_FLAG_G);
        gd32v_adc_dma_complete_cb();
        fw_adc_complete_cb();
    }
}

// i2c0_tx
void DMA0_Channel5_IRQHandler(void)
{
    if (dma_interrupt_flag_get(DMA0, DMA_CH5, DMA_INT_FLAG_FTF)) {     
        dma_interrupt_flag_clear(DMA0, DMA_CH5, DMA_INT_FLAG_G);
        i2c_dma_complete_cb(0);
    }
}